$mod51

ORG 00H

;-- Inisialisasi port
MOV P1,#0FFH
MOV P2,#0FEH

ACALL INIT_SERIAL
MOV A,#30H

;-- pengecekan sensor
PIL : JNB ____,MASUK
      JNB ____,KELUAR
      SJMP PIL
      
;-- pada saat sensor masuk dilewati	  
MASUK : CJNE A,#3AH,TAMBAH
        SJMP BUZZER

;-- Untuk operasi penambahan 
TAMBAH: ___ A
        ACALL BEEP
        ACALL KIRIM
        SJMP PIL

;-- pada saat sensor keluar dilewati
KELUAR : CJNE A,#30H,KURANG
         SJMP BUZZER

;-- Untuk operasi pengurangan 
KURANG :  ___ A
         ACALL BEEP
         ACALL KIRIM
         SJMP PIL

;-- Nyala Buzzer pada saat sudah penuh
BUZZER : ____ P2.0
         SJMP PIL

;-- Untuk 'beep' pada saat sensor dilewati
BEEP : SETB P2.0
       ACALL DELAY
       CLR P2.0
       RET



;-- Inisialisasi Komunikasi Serial (Mode 1, baudrate 9600)
INIT_SERIAL : MOV PCON,#00H
              MOV ____,#40H
              MOV TMOD,____
              MOV TH1,____
              SETB TR1
              SETB ES
              ____ EA
              RET

;-- Untuk kirim karakter 
KIRIM : CLR TI
        MOV ____,A
        RET

;-- Untuk delay		
DELAY: MOV R2,#07H
LAGI : DJNZ R0,LAGI
       DJNZ R1,LAGI
       DJNZ R2,LAGI
       RET
		 
END